--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local _, playerClass = UnitClass("player")
local addonName, addon = ...

-----------------------------
-- functions
-----------------------------
-- Backdrop function, this is also how we cheese borders on things
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		HealthWrapper:SetSize(119,29)
		HealthWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		HealthWrapper:SetBackdropColor(0,0,0,0)
		HealthWrapper:SetBackdropBorderColor(0.5,0.5,0.5,1)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		PowerWrapper:SetSize(119,22)
		PowerWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(0.5,0.5,0.5,1)
end
local function PortraitWrap(frame)
	local PortraitWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PortraitWrapper:SetFrameLevel(1)
		PortraitWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PortraitWrapper:SetSize(54,52)
		PortraitWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PortraitWrapper:SetBackdropColor(0,0,0,1)
		PortraitWrapper:SetBackdropBorderColor(0.5,0.5,0.5,1)
end
local PartyMover = CreateFrame("Frame","PartDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	PartyMover:SetSize(130,340)
	PartyMover:SetPoint("CENTER",UIParent,-435,-35)
	
	PartyMover:SetClampedToScreen(true)
	PartyMover:SetClampRectInsets(0, 0, 0,0)
	
local PartyMoverText  = PartyMover:CreateFontString(nil, "OVERLAY")
	PartyMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	PartyMoverText:SetPoint("CENTER",PartyMover,"CENTER", 0,0); 
	PartyMoverText:SetText("")
	
	local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.EnableParty == true then 
				Inked.db.profile.PartyX = 0
				Inked.db.profile.PartyY = 0
				local point, relativeTo, relativePoint, xOfs, yOfs = PartyMover:GetPoint(n)
				Inked.db.profile.PartyX = xOfs
				Inked.db.profile.PartyY = yOfs
				Inked.db.profile.PartyPoint = point
				PartyMover:SetMovable(true)
				PartyMover:EnableMouse(true)
				PartyMover:RegisterForDrag("LeftButton")
				PartyMover:SetScript("OnDragStart", PartyMover.StartMoving)
				PartyMover:SetScript("OnDragStop", PartyMover.StopMovingOrSizing)
				PartyMover:SetUserPlaced(true)
				PartyMoverText:SetText("Party")
				CreateMoverBackdrop(PartyMover)
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

------------------------------------------------------------------
-- Shared settings
------------------------------------------------------------------------
local function Shared(self, unit, isSingle)
if Inked.db.profile.EnableParty == false then return end
		
	unit = gsub(unit, "%d", "")

	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	
	
	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PartyHealthStatusBar))
	

	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetHeight(25)
	HealthWrap(Health)
	CreateBackdrop(Health)
	
	-- Options
--	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	
	--end
	 local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PartyPowerStatusBar))
	Power:SetHeight(14)
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-18)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	PowerWrap(Power)
	CreateBackdrop(Power)
	

	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC 
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg
	
	-----------------------------
	if Inked.db.profile.PartyAuras == true then
		local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 110,-20)
		Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 190, -20)
		Auras:SetHeight(20 + 4)
		Auras.disableMouse = false

		Auras.size = 20
		Auras.onlyShowPlayer = false
		Auras.gap = 2
		Auras.spacing = 2
		Auras.showStealableAuras = true
		Auras.disableCooldown = false
		Auras.num = 32

		Auras.PostCreateIcon = Aura_PostCreateIcon
		self.Auras = Auras
	end
	 -- 3D Portrait

    local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	
    Portrait:SetSize(43, 41)
    Portrait:SetPoint('RIGHT', self, 'LEFT',-7,1)
	PortraitWrap(Portrait)
 
    self.Portrait = Portrait
	
	
	--Text

	--Name
	local NameText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	NameText:SetPoint("TOP",Health,0,18) -- but anchor to the base element so it doesn't wiggle
	NameText:SetFont(LSM:Fetch("font", Inked.db.profile.PartyNamefont), Inked.db.profile.PartyNameFontSize, Inked.db.profile.PartyNameOutline)
	NameText:SetJustifyH("CENTER")
	NameText:SetWidth(100)
	self:Tag(NameText, "[name]") -- oUF will automagically update it!
	Health.text = NameText
	
	--Health Percent
	local HealthText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	HealthText:SetPoint("CENTER",Health,0,-2) -- but anchor to the base element so it doesn't wiggle
	HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.PartyHealthfont), Inked.db.profile.PartyHealthFontSize, Inked.db.profile.PartyHealthOutline)
	HealthText:SetJustifyH("RIGHT")
	self:Tag(HealthText, "[perhp]".." %") 
	Health.text = HealthText

	local PowerText = Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	PowerText:SetPoint("CENTER", Power, 0,0) -- but anchor to the base element so it doesn't wiggle
	PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.PartyPowerfont), Inked.db.profile.PartyPowerFontSize, Inked.db.profile.PartyPowerOutline)
	PowerText:SetJustifyH("CENTER")
	self:Tag(PowerText, "[perpp]".." %")
	Power.text = PowerText
	
	local LevelText = Health:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	LevelText:SetPoint('BOTTOM', Health, 'TOP',-80,5) -- but anchor to the base element so it doesn't wiggle
	LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.PartyLevelfont), Inked.db.profile.PartyLevelFontSize, Inked.db.profile.PartyLevelOutline)
	LevelText:SetJustifyH("LEFT")
	self:Tag(LevelText, "[level]") 
	Health.text = LevelText
	-----------------------------
		
	
	
	
	-- Rez Icon
	-- Position and sizew
	local ResurrectIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	ResurrectIcon:SetSize(24, 24)
	ResurrectIcon:SetPoint('TOP', self, 'BOTTOM',40,-10)
   
	-- Register it with oUF
	self.ResurrectIcon = ResurrectIcon
	
	-----------------------------
	-- Raid icons
	-- Position and size
	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self.Health,23,0)
	
	-- Register it with oUF
	self.RaidTargetIndicator = RaidTargetIndicator
	
	-----------------------------
	--Group roles
	 -- Position and size
    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 27)
    GroupRoleIndicator:SetPoint('RIGHT', self.Health,23,24)

    -- Register it with oUF
    self.GroupRoleIndicator = GroupRoleIndicator
	-- Raid Roles
	
	-- Position and size
	local RaidRoleIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidRoleIndicator:SetSize(24, 24)
	RaidRoleIndicator:SetPoint('RIGHT', self.Health,23,-24)
   
	-- Register it with oUF
	self.RaidRoleIndicator = RaidRoleIndicator
	
	  -- Position and size
    local LeaderIndicator = self:CreateTexture(nil, 'OVERLAY')
    LeaderIndicator:SetSize(24, 24)
    LeaderIndicator:SetPoint('TOP', self,-50,25)
	

    -- Register it with oUF
    self.LeaderIndicator = LeaderIndicator
	
	    -- Position and size
    local ReadyCheckIndicator = self:CreateTexture(nil, 'OVERLAY')
    ReadyCheckIndicator:SetSize(24, 24)
    ReadyCheckIndicator:SetPoint('BOTTOM', self, 'TOP',-30,0)

    -- Register with oUF
    self.ReadyCheckIndicator = ReadyCheckIndicator
	
	
	
   	------------------------
	-- Plugin: oUF_Smooth --
	------------------------
	
		self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end
	
   
   	----------------------------
	-- Plugin: oUF_SpellRange --
	----------------------------
	
	self.SpellRange = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	--Range
	if unit == "pet" or unit == "party" or unit == "partypet" then
		self.Range = {
			insideAlpha = 1,
			outsideAlpha = 0.5,
		}
	end
	----------------------------
	-- Plugin: oUF_RaidDebuff --
	----------------------------
	
	local dbh = self:CreateTexture(nil, "OVERLAY")
	dbh:SetAllPoints(self)
	dbh:SetTexture("cfg.statusbar_texture")
	dbh:SetBlendMode("ADD")
	dbh:SetVertexColor(0,0,0,0) -- set alpha to 0 to hide the texture
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlight = dbh
	
	
	
end

--Spawn Frames
oUF:RegisterStyle('InkedParty', Shared)
oUF:Factory(function(self)
if Inked.db.profile.EnableParty == false then return end
	self:SetActiveStyle'InkedParty'
		
	local party = self:SpawnHeader(
    nil, nil, 'party,solo',
    'showParty', true,
	'showRaid', true,
    'showPlayer', true,
    'showSolo', Inked.db.profile.ShowSolo ,
	'groupBy', 'ASSIGNEDROLE',
	'groupingOrder', 'TANK,HEALER,DAMAGER',
    'xOffset', 0,
    'yoffset', -5,
   'oUF-initialConfigFunction', [[
        self:SetHeight(45)
        self:SetWidth(110)
    ]],
    'maxColumns', 5,
    'unitsperColumn', 1,
    'columnSpacing', 40,
    'columnAnchorPoint', "TOP"
)
	-- party:SetManyAttributes(
	-- "columnSpacing", 75,
	-- "unitsPerColumn", 2,
	-- "maxColumns", 2,
	-- "columnAnchorPoint", "LEFT",
	-- "yOffset", -25
	-- )
	-- local party = oUF:Spawn('header', 'oUF_Party')
	-- party:SetPoint('BOTTOM', UIParent, 'BOTTOM', 0, 300)
	-- party:SetManyAttributes('xOffset', 20, 'showParty', true, 'unitsPerColumn', 1)

	PartyX = Inked.db.profile.PartyX
	PartyY = Inked.db.profile.PartyY
	--party:SetPoint('TOPLEFT', UIParent,'TOPLEFT', PartyX, PartyY)

	if Inked.db.profile.PartyPoint == nil then
		 party:SetPoint("TOPLEFT",UIParent,Inked.db.profile.PartyX,Inked.db.profile.PartyY)
		PartyMover:SetPoint("TOPLEFT",UIParent,Inked.db.profile.PartyX,Inked.db.profile.PartyY)
	  else
		 party:SetPoint(Inked.db.profile.PartyPoint,UIParent,Inked.db.profile.PartyX,Inked.db.profile.PartyY)
		PartyMover:SetPoint(Inked.db.profile.PartyPoint,UIParent,Inked.db.profile.PartyX,Inked.db.profile.PartyY)
	  end



end)